/*******************************************************************
                      C O P Y R I G H T  (c) 1998
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 -------------------------------------------------------------------

 input.c - Input functions; hide/display numpad, keypad.

 -------------------------------------------------------------------
 *******************************************************************
 * $Source: $
 * $Date: $
 * $Revision: $
 *******************************************************************
*/


/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include <numpad.h>
#include <keypad.h>
#include "local.h"
#include "abimport.h"
#include "proto.h"


int input_number( PtWidget_t       *widget,
                  ApInfo_t         *apinfo,
                  PtCallbackInfo_t *cbinfo )
{
    PhPoint_t  pos, offset;
    PhRect_t   extent;

    apinfo = apinfo;

    PtWidgetExtent( widget, &extent );

    PtGetAbsPosition( widget, &pos.x, &pos.y );

    offset.x = pos.x - extent.ul.x;
    offset.y = pos.y - extent.ul.y;

    PtTranslateRect( &extent, &offset );

    if ( !(cbinfo->event->processing_flags & Ph_FAKE_EVENT) )
    {
        hide_keypad( );
        show_numpad( NUMPAD_AUTO_HIDE, &pos, &extent );
    }

    return( Pt_CONTINUE );
}


int input_alpha( PtWidget_t       *widget,
                 ApInfo_t         *apinfo,
                 PtCallbackInfo_t *cbinfo )
{
    PhPoint_t  pos, offset;
    PhRect_t   extent;

    apinfo = apinfo;

    PtWidgetExtent( widget, &extent );

    PtGetAbsPosition( widget, &pos.x, &pos.y );

    offset.x = pos.x - extent.ul.x;
    offset.y = pos.y - extent.ul.y;

    PtTranslateRect( &extent, &offset );

    if ( !(cbinfo->event->processing_flags & Ph_FAKE_EVENT) )
    {
        hide_numpad( );
        show_keypad( KEYPAD_AUTO_HIDE, &pos, &extent );
    }

    return( Pt_CONTINUE );
}


int input_done( PtWidget_t       *widget,
                ApInfo_t         *apinfo,
                PtCallbackInfo_t *cbinfo )
{
    widget = widget, apinfo = apinfo, cbinfo = cbinfo;

    hide_numpad( );
    hide_keypad( );

    return( Pt_CONTINUE );
}

