/********************************************************************
                      C O P Y R I G H T  (c) 1998
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 --------------------------------------------------------------------

 args.c - Command line argument parsing code.

 --------------------------------------------------------------------
    $Source: $
    $Date: $
    $Revision: $
*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <photon/PhT.h>
#include <photon/PtT.h>

#include "abdefine.h"
#include "args.h"


int        OneShot;
int        LocationSpecified;
PhPoint_t  Location;
int        AvoidAreaSpecified;
PhRect_t   AvoidArea;


char *Options = AB_OPTIONS "1p:a:";


void parse_args( int argc, char *argv[] )
{
    int   c, count;

    while ( -1 != ( c=getopt( argc, argv, Options ) ) )
    {
        switch (c)
        {
            case '1':
                OneShot = Pt_TRUE;
                break;

            case 'p':
                LocationSpecified = Pt_TRUE;

                count = sscanf( optarg, "%hd,%hd",
                                &Location.x, &Location.y );
                if ( count != 2 )
                {
                    fprintf( stderr, "Invalid -p option format.\n" );
                    exit ( -1 );
                }
                break;

            case 'a':
                AvoidAreaSpecified = Pt_TRUE;

                count = sscanf( optarg, "%hd,%hd,%hd,%hd",
                                &AvoidArea.ul.x, &AvoidArea.ul.y,
                                &AvoidArea.lr.x, &AvoidArea.lr.y  );
                if ( count != 4 )
                {
                    fprintf( stderr, "Invalid -a option format.\n" );
                    exit ( -1 );
                }
                break;

            default:
                if ( !strchr( AB_OPTIONS, c ) )
                {
                    fprintf( stderr, "Option \"%c\" not recognized.\n", c );
                    exit ( -1 );
                }
        }
    }

    return;
}

