/*******************************************************************
                      C O P Y R I G H T  (c) 1998
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 -------------------------------------------------------------------

 drag.c - Drag support for numpad/keypad utilities.

 -------------------------------------------------------------------
 *******************************************************************
 * $Source: $
 * $Date: $
 * $Revision: $
 *******************************************************************
*/


/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"


int drag_init( PtWidget_t       *widget,
               ApInfo_t         *apinfo,
               PtCallbackInfo_t *cbinfo )
{
    PhRect_t   *pointer;
    PhRid_t     rid;
    PhRegion_t  region;
    PhRect_t    rect;

    widget = widget, apinfo = apinfo;

    pointer = PhGetRects( cbinfo->event );

    rid = PtWidgetRid( ABW_base );

    PhRegionQuery( rid, &region, &rect, NULL, 0 );

    /* ABW_base's region is a window region, but we want to deal with
       its parent, the window manager region. ('winview' is a good thing.) */

    rid = region.parent;

    PhRegionQuery( rid, &region, &rect, NULL, 0 );

    /* We start the drag, and the window manager takes it over. */

    PhInitDrag( rid,
                Ph_TRACK_DRAG | Ph_DRAG_TRACK,
                pointer,
                NULL,
                cbinfo->event->input_group,
                0, 0, NULL );

    return( Pt_CONTINUE );
}

