/*******************************************************************
                      C O P Y R I G H T  (c) 1998
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 -------------------------------------------------------------------

 ifns.c - Interface functions for the numpad utility.

 -------------------------------------------------------------------
 *******************************************************************
 * $Source: $
 * $Date: $
 * $Revision: $
 *******************************************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <sys/name.h>
#include <sys/kernel.h>

#include <numpad.h>

#include "msg.h"


int show_numpad( int auto_hide, PhPoint_t *topleft, PhRect_t *avoid )
{
    int    error = 0;
    pid_t  pid;
    short  msg;
    int    argc;
    char  *argv[ 20 ];
    char   position_buf[ 80 ];
    char   avoid_buf[ 80 ];

    pid = qnx_name_locate( 0, REGISTERED_NAME, 0, NULL );

    if ( pid < 0 )
    {
        argc = 0;

        argv[argc++] = "numpad";

        if ( auto_hide )
        {
            argv[argc++] = "-1";
        }

        if ( topleft != NULL )
        {
            sprintf( position_buf, "-p %d,%d", topleft->x, topleft->y );

            argv[argc++] = position_buf;
        }

        if ( avoid != NULL )
        {
            sprintf( avoid_buf, "-a %d,%d,%d,%d",
                     avoid->ul.x, avoid->ul.y,
                     avoid->lr.x, avoid->lr.y  );

            argv[argc++] = avoid_buf;
        }

        argv[argc] = NULL;

        pid = spawnvp( P_NOWAITO, "numpad", argv );

        msg = MSG_VERIFY_ALIVE;

        error = Send( pid, &msg, NULL, sizeof(msg), 0 );
    }

    return ( error );
}


int hide_numpad( void )
{
    int    error = 0;
    pid_t  pid;
    short  msg;

    pid = qnx_name_locate( 0, REGISTERED_NAME, 0, NULL );

    if ( pid > 0 )
    {
        msg = MSG_CODE_QUIT;

        error = Send( pid, &msg, NULL, sizeof(msg), 0 );
    }

    return ( error );
}

