/*******************************************************************
                      C O P Y R I G H T  (c) 1998
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 -------------------------------------------------------------------

 input_group.c - Functions for dealing with input groups.

 -------------------------------------------------------------------
 *******************************************************************
 * $Source: $
 * $Date: $
 * $Revision: $
 *******************************************************************
*/

#include <assert.h>

#include <Ph.h>

#include "input_group.h"


int get_input_group( void )
{
    char       *ig_string;
    int         input_group;
    PhRid_t     rid;
    PhRect_t    rect;
    PhRegion_t  region;

    /* Much of this code is referenced from
       /usr/photon/apps/savers/puzzle.c          */

    ig_string = getenv( "PHIG" );
    if ( ig_string )
        input_group = atoi( ig_string );
    else
        input_group = 0;

    PhQueryRids( 0, 0, input_group, Ph_INPUTGROUP_REGION, 0, 0, 0, &rid, 1 );
    PhRegionQuery( rid, &region, &rect, NULL, 0 );

    input_group = region.input_group;

    return ( input_group );
}


PhRect_t *get_input_group_bounds( PhRect_t *rect )
{
    int         input_group;

    /* Much of this code is referenced from
       /usr/photon/apps/savers/puzzle.c          */

    assert( rect != NULL );

    input_group = get_input_group( );

    PhWindowQueryVisible( Ph_QUERY_INPUT_GROUP | Ph_QUERY_EXACT,
                          0, input_group, rect );

    return ( rect );
}

